//#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;
uniform int type;
uniform int kernel;
uniform float width;
uniform int quality;
uniform vec4 gamma;

void main (void)
{
    
    gl_FragColor = vec4(0, 0, 0 ,0);

    if (kernel == 0){
	if (type == 0){
	    for (int i = 0; i < quality*2+1; i++){
		float dx = float(i-quality) / float(quality) * width;
		vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st+vec2(dx, 0));
		if (texColor[3] > 1){
		    texColor[0] *= texColor[3];
		    texColor[1] *= texColor[3];
		    texColor[2] *= texColor[3];
		    texColor[3] = 1;
		}

		if (gamma[0] != 0.0) texColor = pow(texColor, gamma);
		gl_FragColor += texColor / float(quality*2+1);
	    }
	}
	if (type == 1)
	    for (int i = 0; i < quality*2+1; i++){
		float dy = float(i-quality) / float(quality) * width;
		vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st+vec2(0, dy));
		if (texColor[3] > 1){
		    texColor[0] *= texColor[3];
		    texColor[1] *= texColor[3];
		    texColor[2] *= texColor[3];
		    texColor[3] = 1;
		}

		if (gamma[0] != 0.0) texColor = pow(texColor, gamma);
		gl_FragColor += texColor / float(quality*2+1);
	    }
    }

    if (kernel == 1){
	float sum = 0;
	if (type == 0){
	    for (int i = 0; i < quality*2+1; i++){
		if (i == quality) continue;
		float dx = float(i-quality) / float(quality) * width;
		vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st+vec2(dx, 0));
		if (texColor[3] > 1){
		    texColor[0] *= texColor[3];
		    texColor[1] *= texColor[3];
		    texColor[2] *= texColor[3];
		    texColor[3] = 1;
		}
		if (gamma[0] != 0.0) texColor = pow(texColor, gamma);

		float x = float(i-quality) / float(quality) * 1.5;
		float f = 1.0 / sqrt(2*3.14159) * exp(-x*x / 2.0);
		float f2 = float(quality / 1.5);
	    
		sum = sum + f/f2;
		vec4 dCol = texColor * (f / f2);
		//if (gamma[0] != 0.0) dCol = pow(dCol, gamma);
		
		gl_FragColor += dCol;
	    }
	}
	if (type == 1)
	    for (int i = 0; i < quality*2+1; i++){
		if (i == quality) continue;
		float dy = float(i-quality) / float(quality) * width;
		vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st+vec2(0, dy));
		if (texColor[3] > 1){
		    texColor[0] *= texColor[3];
		    texColor[1] *= texColor[3];
		    texColor[2] *= texColor[3];
		    texColor[3] = 1;
		}
		if (gamma[0] != 0.0) texColor = pow(texColor, gamma);
		
		float x = float(i-quality) / float(quality) * 1.5;
		float f = 1.0 / sqrt(2*3.14159) * exp(-x*x / 2.0);
		float f2 = float(quality / 1.5);
	    
		sum = sum + f/f2;
		vec4 dCol = texColor * (f / f2);
		//if (gamma[0] != 0.0) dCol = pow(dCol, gamma);
		
		gl_FragColor += dCol;
	    }

	vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st);
	if (gamma[0] != 0.0) texColor = pow(texColor, gamma);
	
	gl_FragColor += texColor * (1.0-sum);
    }

    return;
}
