// Outline.vert

#version 120
#extension GL_EXT_gpu_shader2 : enable
#extension GL_EXT_gpu_shader3 : enable
#extension GL_EXT_gpu_shader4 : enable

uniform float boldness;

varying vec3 positionIn;
varying vec3 normalIn;
varying vec4 GLSubPosition;

void main(void)
{
    gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
    
    gl_Position = ftransform();
    //gl_ModelViewProjectionMatrix * gl_Vertex;
    
    float distance = gl_Position.z;
    GLSubPosition = gl_Vertex + vec4(gl_Normal, 0) * 0.2 * boldness * sqrt(distance);
    GLSubPosition = gl_ModelViewProjectionMatrix * GLSubPosition;

    positionIn = vec3(gl_ModelViewMatrix * gl_Vertex);
    normalIn = gl_NormalMatrix * gl_Normal;
}
